/*********************** INCLUDES.H ***********************
*        #include's other files and sets up prototypes
*        Prototypes only under MS-DOS since Unix compilers
*           are still not ANSI-compliant.
*        Part of LJDFGRAF.C -- by David Babcock
**********************************************************/

#include <dos.h>
#include <limits.h>
#include <math.h>
#include <signal.h>
#include <stdarg.h>
#include <stddef.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/* test for Microsoft C 5.x */
#ifdef M_I86
/* msc's math.h defines a function named y1() ! */
 #define y1 Y1
/* msc is missing MK_FP */
 #define MK_FP(s,o) ((void far *) (((unsigned long)(s) << 16) | (unsigned)(o)))
#endif

#if ( MSDOS | __MSDOS__ )
char    *g_EMSframe ;
#else
char    *g_base [ EMS_PAGES ] ;
#define labs(x) ((x)<0L?-(x):(x))
/* the above was not supplied with HP-UX */
#endif

#if ( MSDOS | __MSDOS__ )
static  int komp(struct point *a,struct point *b);
static  void blacken(int y,int x_start,int x_end);
extern  void g_openPoly(void );
extern  void g_closePoly(void );
extern  void g_line(int x1,int y1,int x2,int y2,int width);
static  void addRule(int x_start,int y_start,int x_end,int y_end);
extern  void g_fillPoly(struct point *g_pointArray,int arrayPtr);
static  void riteDot(int x,int y);
static  void bline(int x1,int y1,int x2,int y2,int botpix,int toppix);
static  void fill_line(int x1,int y1,int x2,int y2);
static  void rite(int x,int y);
static  void flush(void );
extern  int g_getEMShandle(int pages);
extern  unsigned int g_getEMSframe(void );
extern  int g_mapEMSpage(int page);
extern  int g_freeEMShandle(int handle);
extern  void g_accessRow(int y,int write,char *buf);
extern  int g_init16(void );
extern  void g_outRow(char *buf);
extern  void g_outEmptyRow(void );
static  int compress(char *outRow,char *inRow,int bytes);
extern  void g_ellipse(int x0,int y0,int x1,int y1,int x2,int y2);
static  void gdot(int x,int y);
extern  void g_bezier(int _x1,int _y1,int _x2,int _y2,
             int _xc1,int _yc1,int _xc2,int _yc2);
static  void _bezier(long x1,long y1,long x2,long y2,
             long xc1,long yc1,long xc2,long yc2);
static  void plotxy(int x,int y);
extern  int g_clip(int *x1Int,int *y1Int,int *x2Int,int *y2Int,
             int x1,int y1,int x2,int y2,int XL,int YB,int XR,int YT);
static  int xIntercept(int y,int x1,int y1,int x2,int y2);
static  int yIntercept(int x,int x1,int y1,int x2,int y2);
extern  void ctrlC(void );
#endif
