' STARTVBS.VBS - Windows Scripting Host Script to
' move files into or out of the StartUp folder.
' ==== main program body begins ====
Option Explicit
Dim WSO, FSO, SU, TMP, YesNo
' Get the location of the Startup folder
Set WSO = WScript.CreateObject("WScript.Shell")
SU = WSO.SpecialFolders("Startup")
' Create an object for manipulating the file system
Set FSO = CreateObject("Scripting.FileSystemObject")
' Name directory that holds deactivated Startup items
TMP = "c:\StartUp"
If FolderSize(SU) = 0 Then
  If FolderSize(TMP) <> 0 Then
    Activate
  Else
    MsgBox "There are no files in the startup folder or in "+_
      "the temporary folder", vbOKOnly + vbCritical, _
      "Nothing to do!"
  End If
Else
  Deactivate
End If
' ==== main program body ends ====

Sub Activate
  YesNo = MsgBox("Activate StartUp Folder?", vbYesNo + vbQuestion, _
    "Configure StartUp")
  If YesNo = vbYes And FSO.FolderExists(TMP) = True Then
    If FolderSize(TMP) <> 0 Then
      Call Relocate(TMP, SU)
      FSO.DeleteFolder(TMP)
    End If
  End If
End Sub

Sub Deactivate
  YesNo = MsgBox("Deactivate StartUp Folder?", vbYesNo + vbQuestion, _
    "Configure StartUp")
  If YesNo = vbYes Then
    If FSO.FolderExists(TMP) = False Then
      FSO.CreateFolder(TMP)
    End If
    Call Relocate(SU, TMP)
  End If
End Sub

Sub Relocate(source, dest)
' Move files from source folder to dest folder
  Dim AFolder, TheFiles, AFile
  Set AFolder = FSO.GetFolder(source)
  Set TheFiles = AFolder.Files
  For Each AFile in TheFiles
    FSO.CopyFile AFile, (dest) & "\"
    FSO.DeleteFile(AFile)
  Next
End Sub

Function FolderSize(folderpath)
' Returns the size in bytes of all files and subfolders
  If FSO.FolderExists(folderpath) Then
    Dim AFolder
    Set AFolder = FSO.GetFolder(folderpath)
    FolderSize = AFolder.Size
  Else
    FolderSize = 0
  End If
End Function

