'////////////////////////////////////////////////////////////
'// Filename : ViewAsText.vbs
'//
'// Purpose : Add a "View as Text" context menu option to
'//           all unknown filetypes
'//
'// NOTE : Notepad.exe is used by default as the text viewer
'////////////////////////////////////////////////////////////

'// Globals
'//
'// WSHShell - access to the registry (as well as other things)
'// unknownKey - location of the unknown filetype shell commands
'// contextString - what will appear in the context menu
'//           & before a letter means this letter is underlined
'// command - name of the subkey to store the command
'//           to run when this item is selected
'// BS - a back slash

Dim WSHShell
Set WSHShell = WScript.CreateObject("WScript.Shell")
Const unknownKey = "HKEY_CLASSES_ROOT\Unknown\Shell"
Const contextString = "View as Te&xt"
Const command = "Command"
Const BS = "\"

'//====================================================
'// ::SKELETON::
'// - Get notepad's path
'// - Create command to open notepad with a given file
'// - Assign the command to unknown files
'// - Tell the User what you did
'//====================================================

Dim s
s = "%windir%\notepad.exe"
s = WSHShell.ExpandEnvironmentStrings(s)
s = s + " %1"

dim newKey
newKey = unknownKey + BS + contextString + BS
WSHShell.RegWrite newKey, ""
newKey = newKey + command + BS
WSHShell.RegWrite newKey, s
MsgBox("You can right-click an unknown" +vbCrLf + _
       "file and select 'View as Text'.")

